//
//  RootViewController.m
//  ClientSocket
//
//  Created by fred yu on 8/4/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "RootViewController.h"
#import "ClientSocket.h"
#import "ByteArray.h"


@implementation RootViewController

#pragma mark -
#pragma mark View lifecycle


- (void)viewDidLoad {
    [super viewDidLoad];

	ClientSocket * 	mysocket = [ClientSocket clientWithHost:@"192.168.0.14" port:4530 andDelegate:nil];


	messageData = [NSMutableData data];
	
	unsigned short startToken = 0xFFFF;
	
	[messageData appendBytes:&startToken length:sizeof(startToken)];

	
	unsigned short messageType = 116;

	[self addUnsignedShort:messageType];

	
	int messageID = 1;
	
	[self addInt:messageID];
	
	
	unsigned char tempChar = 0;
	
	int passwordLen = 8;
	
	
	int messageBodyLen = 12;
	
	[self addInt:messageBodyLen];
	

	NSString *userID = @"aa01";
	unsigned char userIDLen = ([userID length]<=11)?[userID length]:11;

	[self addUnsignedChar:userIDLen];
	
	ByteArray * userIDByteArray =  [ByteArray createFromString:userID];
	[messageData appendData:[userIDByteArray toNSData]];

	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	
	
	NSString *destUserID = @"_0";
	unsigned char destUserIDLen = ([destUserID length]<=11)?[destUserID length]:11;
	
	[self addUnsignedChar:destUserIDLen];
	
	[messageData appendData:[destUserID dataUsingEncoding:NSUTF8StringEncoding]];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	
	
	[self addInt:passwordLen];
	
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];
	[self addUnsignedChar:tempChar];

	
	if([mysocket connect] == SCCInitOK){
		NSLog(@"RootViewController::viewDidLoad mysocket connect] == SCCInitOK");
		
		[mysocket setIsConnected:YES];
		[mysocket sendData:messageData];
	}
		
}

- (void)addUnsignedShort:(unsigned short)uShort{
	const int size = 2;
	union {
		unsigned short us;
		short ss;
		unsigned char buffer[size];
	} u;

	u.us = uShort;
	
	[messageData appendBytes:u.buffer length:size];
}

- (void)addInt:(int)iInt{
	const int size = 4;
	union {
		int sl;
		unsigned char buffer[size];
	} u;
	u.sl = iInt;
	
	[messageData appendBytes:u.buffer length:size];
}

- (void)addUnsignedChar:(unsigned char)uChar{
	unsigned char *buffer;
	buffer = &uChar;
	[messageData appendBytes:buffer length:1];
}





/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
}
*/

/*
 // Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations.
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
 */


#pragma mark -
#pragma mark Table view data source

// Customize the number of sections in the table view.
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return 0;
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
    }
    
	// Configure the cell.

    return cell;
}

#pragma mark -
#pragma mark Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    
	/*
	 <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
	 [self.navigationController pushViewController:detailViewController animated:YES];
	 [detailViewController release];
	 */
}


#pragma mark -
#pragma mark Memory management

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Relinquish ownership any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    // Relinquish ownership of anything that can be recreated in viewDidLoad or on demand.
    // For example: self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end

