//
//  SoccerMsg.m
//  ClientSocket
//
//  Created by fred yu on 8/4/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "SoccerMsg.h"



@implementation SoccerMsg

static SoccerMsg *sharedInst = nil;

@synthesize _stMsgHead = m_stMsgHead;
@synthesize _stMsgBody = m_stMsgBody;

+ (id) sharedSoccerMsg{
	
	@synchronized( self ) {
        if ( sharedInst == nil ) {
            
            sharedInst = [[self alloc] init];
        }
    }
	
    return sharedInst;
}

- (id) init{
	
	if ( sharedInst != nil ) {
		
	} 
	else if ( (self = [super init]) ){
		
		m_stMsgHead = [[MsgHead alloc] init];
		m_stMsgBody = [[MsgBody alloc] init];
	}
	return self;
}

- (NSMutableData*) SendData:(protocolName)nameSend{
	
	NSMutableData*	sendData = [NSMutableData data];
	NSMutableData*	headData = [NSMutableData data];
	NSMutableData*	bodyData = [NSMutableData data];
	
	bodyData = [m_stMsgBody SendData:nameSend];
	
	m_stMsgHead._uiMsgID = m_stMsgBody._uiMsgID;
	m_stMsgHead._uiBodyLength = m_stMsgBody._uiBodyLength;
	headData = [m_stMsgHead SendData];
	
	//short	len = [bodyData length] + [headData length] + 2;
	//sendData = ReadData(sendData, len);
	[sendData appendData:headData];
	[sendData appendData:bodyData];
	
	return sendData;
}

- (void) GetData:(NSData*)data Start:(int)start{
	
	[m_stMsgHead GetData:data];
	
	protocolName nameGet;
	switch (m_stMsgHead._uiMsgID) {
		case MsgID_LoginServer_Request:
			nameGet = Protocol_LoginServer_Request;
			break;
			
		case MsgID_LoginServer_Response:
			nameGet = Protocol_LoginServer_Response;
			break;
			
		case MsgID_LoginServer_Notify:
			nameGet = Protocol_LoginServer_Notify;
			break;
			
		case MsgID_LogoutServer_Request:
			nameGet = Protocol_LogoutServer_Request;
			break;
			
		case MsgID_LogoutServer_Response:
			nameGet = Protocol_LogoutServer_Response;
			break;
			
		case MsgID_LogoutServer_Notify:
			nameGet = Protocol_LogoutServer_Notify;
			break;
			
		
			
		default:
			break;
	}
	
	[m_stMsgBody GetData:data ProtocolIndex:nameGet];
}

- (void) dealloc{
	
	[m_stMsgHead release];
	m_stMsgHead = nil;
	[m_stMsgBody release];
	m_stMsgBody = nil;
	
	[super dealloc];
}

@end